use based::{
    request::{RequestContext, StringResponse},
    ui::components::Shell,
};
use maud::{html, Render};

use based::ui::prelude::*;

use crate::config::ProjectConfig;

pub fn gen_shell() -> Shell {
    Shell::new(
        html! {
            meta charset="UTF-8";
            title { "Umbrella ☂️"};
        },
        Nothing(),
        Background(Text("").white()).color(Colors::Black),
    )
    .use_ui()
}

pub async fn gen_site(c: &ProjectConfig, ctx: RequestContext) -> StringResponse {
    let shell = gen_shell();

    let content = Div()
        .vanish()
        .push(Container(
            Div()
                .vanish()
                .push(Text("Umbrella ☂️")._3xl().bold())
                .push(html! {
                    @for (key, _) in c {
                        (Link(&format!("/prj/{key}"), Text(&key)))
                    }
                }),
        ))
        .render();

    shell.render_page(content, "Umbrella", ctx).await
}
